package com.vendor.burn.transportWorks;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.config.PreferenceConfig;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.devices.IFrameSetting;
import com.vendor.burn.model.receive.ReceiveTimeOutException;
import com.vendor.burn.model.struct.XmodelParameter;
import com.vendor.burn.preferences.FastbootPreferences;
import com.vendor.burn.transportWorks.AbstractTransportWorker;
import com.vendor.burn.utilitily.ToolUtils;
import java.io.File;
import java.io.IOException;
import org.eclipse.core.runtime.SubMonitor;

public class NetTransportWorker extends AbstractTransportWorker {
  public NetTransportWorker(IFrameSetting frameSetting, IBurner burner) {
    super(frameSetting, burner);
  }
  
  public boolean downloadFileByTransport(SubMonitor subProgressMonitor, XmodelParameter xmodelPar, File partfile, int progressWork) throws IOException, ReceiveTimeOutException {
    boolean isOpenTftpCrcCheck = true;
    if (ToolUtils.isCmdLine()) {
      isOpenTftpCrcCheck = PreferenceConfig.isTftpCrcCheck();
    } else {
      isOpenTftpCrcCheck = FastbootPreferences.isOpenTftpCrcCheck();
    } 
    if (isOpenTftpCrcCheck) {
      int retransmitCount = 0;
      while (retransmitCount < 3) {
        if (tftpAndCheckCRC(subProgressMonitor, partfile, isOpenTftpCrcCheck)) {
          subProgressMonitor.worked(progressWork);
          return true;
        } 
        retransmitCount++;
      } 
    } else if (tftpAndCheckCRC(subProgressMonitor, partfile, isOpenTftpCrcCheck)) {
      subProgressMonitor.worked(progressWork);
      return true;
    } 
    returnError(Messages.Partition_TFTP_CRC_Failed);
    return false;
  }
}
